#include "StdAfx.h"

#define SERVICE_NOT_PRESENT 0 

HOOKPROC hkprcSysMsg; 
static HHOOK hhookSysMsg; 

BOOL bCreated = FALSE;
BOOL UnloadProfile;
BOOL RebootNow = FALSE;

BOOL RebootInitiated = FALSE;

#define FAST_REBOOT_APP_CLASS       TEXT("FastRebootAppClass")
#define FAST_REBOOT_SERVICE_NAME    TEXT("FastRebootService")

SERVICE_STATUS_HANDLE StatusHandle;

#pragma pack(push,1)
#pragma pack(1)
struct INJECTORCODE
{
  // push     offset puhandler_libraryname
  BYTE  instr_push_loadlibrary_arg_1;
  DWORD loadlibrary_arg_1;

  // call     [LoadLibraryA]
  WORD  instr_call_loadlibrary_1;
  DWORD adr_from_call_loadlibrary_1;

  // push     offset userenv_libraryname
  BYTE  instr_push_loadlibrary_arg_2;
  DWORD loadlibrary_arg_2;

  // call     [LoadLibraryA]
  WORD  instr_call_loadlibrary_2;
  DWORD adr_from_call_loadlibrary_2;

  // call     [ExitThread]
  BYTE  instr_push_exitthread_arg;
  DWORD exitthread_arg;

  WORD  instr_call_exitthread;
  DWORD adr_from_call_exitthread;

  DWORD addr_loadlibrary;
  DWORD addr_exitthread;
  BYTE  puhandler_libraryname[MAX_PATH];
  BYTE  userenv_libraryname[MAX_PATH];
};
#pragma pack(pop,1)

/*
    Some parts from CRTL
*/
#define _TOLOWER(c) ( ((c) >= 'A') && ((c) <= 'Z') ? ((c) - 'A' + 'a') :\
              (c) )

size_t __cdecl wcslen (
        const wchar_t * wcs
        )
{
        const wchar_t *eos = wcs;

        while( *eos++ ) ;

        return( (size_t)(eos - wcs - 1) );
}

int __cdecl memicmp (
        const void * first,
        const void * last,
        unsigned int count
        )
{
        int f = 0;
        int l = 0;

        while ( count-- )
        {
            if ( (*(unsigned char *)first == *(unsigned char *)last) ||
                 ((f = _TOLOWER( *(unsigned char *)first )) ==
                  (l = _TOLOWER( *(unsigned char *)last ))) )
            {
                first = (char *)first + 1;
                last = (char *)last + 1;
            }
            else
                break;
        }

        return ( f - l );
}

PCHAR __cdecl strrchr (
        PCHAR string,
        CHAR ch
        )
{
        PCHAR start = (PCHAR)string;

        while (*string++)
                ;
        while (--string != start && *string != ch)
                ;

        if (*string == ch)
                return( (PCHAR)string );

        return(NULL);
}
/*
    End of CRTL parts
*/

ULONG (__stdcall *NtShutdownSystem) (
    IN SHUTDOWN_ACTION Action
);

ULONG (__stdcall *NtQuerySystemInformation) (
    ULONG   SystemInformationClass,
    PVOID   SystemInformation,
    ULONG   SystemInformationLength,
    PULONG  ReturnLength
);

BOOL InjectDll(DWORD pid, char *lpszDllName, char *lpszDllNameUserEnv)
{
    HANDLE hProcess;
    BYTE *p_code;
    INJECTORCODE cmds;
    DWORD wr, id;
    HANDLE z;
    HMODULE hDll;

    if(!pid)
        return FALSE;
    hProcess=OpenProcess(PROCESS_CREATE_THREAD|PROCESS_VM_WRITE|PROCESS_VM_OPERATION, FALSE, pid);

    if (hProcess == NULL) return FALSE;
    
    p_code = (BYTE*)VirtualAllocEx(hProcess, 0, sizeof(INJECTORCODE),
                                   MEM_COMMIT, PAGE_EXECUTE_READWRITE);
    if(p_code==NULL) {
        CloseHandle(hProcess);
        return FALSE;
    }

    // Load PUHandler.dll
    cmds.instr_push_loadlibrary_arg_1 = 0x68; 
    cmds.loadlibrary_arg_1 = (DWORD)((BYTE*)p_code 
             + offsetof(INJECTORCODE, puhandler_libraryname));
    
    cmds.instr_call_loadlibrary_1 = 0x15ff;
    cmds.adr_from_call_loadlibrary_1 =
    (DWORD)(p_code + offsetof(INJECTORCODE, addr_loadlibrary));
    
    // Load UserEnv.dll
    cmds.instr_push_loadlibrary_arg_2 = 0x68; 
    cmds.loadlibrary_arg_2 = (DWORD)((BYTE*)p_code 
             + offsetof(INJECTORCODE, userenv_libraryname));
    
    cmds.instr_call_loadlibrary_2 = 0x15ff;
    cmds.adr_from_call_loadlibrary_2 =
    (DWORD)(p_code + offsetof(INJECTORCODE, addr_loadlibrary));
    
    // call ExitThread
    cmds.instr_push_exitthread_arg  = 0x68;
    cmds.exitthread_arg = 0;
    
    cmds.instr_call_exitthread = 0x15ff; 
    cmds.adr_from_call_exitthread = 
    (DWORD)(p_code + offsetof(INJECTORCODE, addr_exitthread));
    
    hDll = GetModuleHandle("kernel32.dll");
    cmds.addr_loadlibrary = (DWORD)GetProcAddress(hDll, "LoadLibraryA");
    
    cmds.addr_exitthread  = (DWORD)GetProcAddress(hDll, "ExitThread");
    
    if(strlen(lpszDllName)>MAX_PATH) {
        VirtualFreeEx(hProcess, (void*)p_code, sizeof(cmds), MEM_RELEASE);
        CloseHandle(hProcess);
        return FALSE;
    }

    strcpy((char*)cmds.puhandler_libraryname, lpszDllName );
    strcpy((char*)cmds.userenv_libraryname, lpszDllNameUserEnv );

    if(!WriteProcessMemory(hProcess, p_code, &cmds, sizeof(cmds), &wr)) {
        VirtualFreeEx(hProcess, (void*)p_code, sizeof(cmds), MEM_RELEASE);
        CloseHandle(hProcess);
        return FALSE;
    }
    
    z = CreateRemoteThread(hProcess, NULL, 0, 
                 (unsigned long (__stdcall *)(void *))p_code, 0, 0, &id);
    if(!z) {
        VirtualFreeEx(hProcess, (void*)p_code, sizeof(cmds), MEM_RELEASE);
        CloseHandle(hProcess);
        return FALSE;
    }

    WaitForSingleObject(z, INFINITE);
    CloseHandle(z);

    VirtualFreeEx(hProcess, (void*)p_code, sizeof(cmds), MEM_RELEASE);
    CloseHandle(hProcess);

    return TRUE;
}

typedef LONG    NTSTATUS;
typedef LONG    KPRIORITY;

#define STATUS_INFO_LENGTH_MISMATCH      (0xC0000004L)

#define SystemProcessesAndThreadsInformation    5

typedef struct _CLIENT_ID {
    DWORD         UniqueProcess;
    DWORD         UniqueThread;
} CLIENT_ID;

typedef struct _UNICODE_STRING {
    USHORT        Length;
    USHORT        MaximumLength;
    PWSTR         Buffer;
} UNICODE_STRING;

typedef struct _VM_COUNTERS {
    SIZE_T        PeakVirtualSize;
    SIZE_T        VirtualSize;
    ULONG         PageFaultCount;
    SIZE_T        PeakWorkingSetSize;
    SIZE_T        WorkingSetSize;
    SIZE_T        QuotaPeakPagedPoolUsage;
    SIZE_T        QuotaPagedPoolUsage;
    SIZE_T        QuotaPeakNonPagedPoolUsage;
    SIZE_T        QuotaNonPagedPoolUsage;
    SIZE_T        PagefileUsage;
    SIZE_T        PeakPagefileUsage;
} VM_COUNTERS;

typedef struct _SYSTEM_THREADS {
    LARGE_INTEGER KernelTime;
    LARGE_INTEGER UserTime;
    LARGE_INTEGER CreateTime;
    ULONG         WaitTime;
    PVOID         StartAddress;
    CLIENT_ID     ClientId;
    KPRIORITY     Priority;
    KPRIORITY     BasePriority;
    ULONG         ContextSwitchCount;
    LONG          State;
    LONG          WaitReason;
} SYSTEM_THREADS, * PSYSTEM_THREADS;

typedef struct _SYSTEM_PROCESSES {
    ULONG             NextEntryDelta;
    ULONG             ThreadCount;
    ULONG             Reserved1[6];
    LARGE_INTEGER     CreateTime;
    LARGE_INTEGER     UserTime;
    LARGE_INTEGER     KernelTime;
    UNICODE_STRING    ProcessName;
    KPRIORITY         BasePriority;
    ULONG             ProcessId;
    ULONG             InheritedFromProcessId;
    ULONG             HandleCount;
    ULONG             Reserved2[2];
    VM_COUNTERS       VmCounters;
#if _WIN32_WINNT >= 0x500
    IO_COUNTERS       IoCounters;
#endif
    SYSTEM_THREADS    Threads[1];
} SYSTEM_PROCESSES, * PSYSTEM_PROCESSES;

DWORD FindProcessPid(WCHAR *ImagePathName) {
    ULONG Status;
    ULONG cbBuffer = 0x8000;
    PVOID pBuffer = NULL;
    ULONG l=0;
    ULONG ImagePathNameLen = wcslen(ImagePathName)*sizeof(WCHAR);
    ULONG pid;

    NtQuerySystemInformation = (unsigned long (__stdcall *)(ULONG   SystemInformationClass,
                                                            PVOID   SystemInformation,
                                                            ULONG   SystemInformationLength,
                                                            PULONG  ReturnLength)) GetProcAddress( GetModuleHandle("ntdll.dll"), "NtQuerySystemInformation" );

    do {
        pBuffer = GlobalAlloc(GMEM_FIXED, cbBuffer);

        Status = NtQuerySystemInformation(
                    SystemProcessesAndThreadsInformation,
                    pBuffer, cbBuffer, NULL);

        if (Status == STATUS_INFO_LENGTH_MISMATCH) {
            GlobalFree(pBuffer);
            cbBuffer *= 2;
        }
    } while (Status == STATUS_INFO_LENGTH_MISMATCH ||
             Status != 0);

    PSYSTEM_PROCESSES pProcesses = (PSYSTEM_PROCESSES)pBuffer;

    for (;;) {
        if ((pProcesses->ProcessName.Length == ImagePathNameLen) &&
            (memicmp(pProcesses->ProcessName.Buffer,ImagePathName, ImagePathNameLen) == 0)) {
            pid = pProcesses->ProcessId;
            GlobalFree(pBuffer);
            return pid;
        }
        if(!pProcesses->NextEntryDelta)
            break;
        l += pProcesses->NextEntryDelta;
        if(l > cbBuffer)
            break;
        pProcesses = (PSYSTEM_PROCESSES)(((LPBYTE)pProcesses)
                        + pProcesses->NextEntryDelta);
        if(l+pProcesses->NextEntryDelta > cbBuffer)
            break;
    }

    GlobalFree(pBuffer);
    return 0;

}

BOOL GainAllPrivileges(void)
{
    HANDLE              hToken;
    PTOKEN_PRIVILEGES   tp;
    DWORD               ReturnLength;
    DWORD               i;
    //
    // obtain the token, first check the thread and then the process
    //
    if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, TRUE, &hToken)){
        if (GetLastError() == ERROR_NO_TOKEN){
            if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
                return FALSE;
        } else return FALSE;
    }

    GetTokenInformation(hToken,TokenPrivileges, NULL,0L, &ReturnLength);
    tp = (PTOKEN_PRIVILEGES)GlobalAlloc(GMEM_FIXED,ReturnLength);
    GetTokenInformation(hToken,TokenPrivileges, tp, ReturnLength, &ReturnLength);

    for (i=0; i<tp->PrivilegeCount;i++) {
        tp->Privileges[i].Attributes = SE_PRIVILEGE_ENABLED;
    }

    if (!AdjustTokenPrivileges(hToken, FALSE, tp, 0, ( PTOKEN_PRIVILEGES)NULL, 0))
         return FALSE;

    if (!CloseHandle(hToken))
         return FALSE;

    GlobalFree(tp);
    return TRUE;
}

ULONG
__stdcall
RebootImmediately(PVOID)
{
    WCHAR SystemRoot[MAX_PATH];
    WCHAR WinLogonPath[MAX_PATH];
    WCHAR WinLogonName[MAX_PATH];

    CHAR SystemRootA[MAX_PATH];
    CHAR UserEnvPath[MAX_PATH];
    CHAR PUHandlerPath[MAX_PATH];
    
    if (UnloadProfile) {
        if(!GetSystemDirectoryW(SystemRoot,MAX_PATH))
            goto nt_shutdown;
        wsprintfW(WinLogonPath,L"\\??\\%s\\winlogon.exe",SystemRoot);
        wsprintfW(WinLogonName,L"winlogon.exe");

        if(!GetSystemDirectoryA(SystemRootA,MAX_PATH))
            goto nt_shutdown;
        wsprintf(UserEnvPath,"%s\\userenv.dll",SystemRootA);

        if(!GetModuleFileName(NULL, PUHandlerPath, MAX_PATH))
            goto nt_shutdown;
        *(strrchr(PUHandlerPath, '\\') + 1) = '\0';
        strcat(PUHandlerPath,"PUHandler.dll");

        if(GainAllPrivileges()) {
            if(!InjectDll(FindProcessPid(WinLogonPath),PUHandlerPath,UserEnvPath)) {
                InjectDll(FindProcessPid(WinLogonName),PUHandlerPath,UserEnvPath);
            }
        }

        ExitWindowsEx(EWX_LOGOFF | EWX_FORCE , 0);
        ExitThread(0);
    } else {
nt_shutdown:
        GainAllPrivileges();
        NtShutdownSystem = (unsigned long (__stdcall *)(enum SHUTDOWN_ACTION_TAG)) GetProcAddress( GetModuleHandle("ntdll.dll"), "NtShutdownSystem" );
        NtShutdownSystem(ShutdownReboot);
        ExitThread(0);
    }
    return 0;
}

LRESULT CALLBACK
MyKeyboardProc(
    int nCode,     // hook code
    WPARAM wParam, // message identifier
    LPARAM lParam  // message data
) {
    if(nCode < 0 || RebootInitiated)
        return CallNextHookEx(hhookSysMsg, nCode, wParam, lParam);

    PKBDLLHOOKSTRUCT hookParams = (PKBDLLHOOKSTRUCT)lParam;

    if(wParam == WM_KEYDOWN || wParam == WM_SYSKEYDOWN) {
        if( (hookParams->scanCode == 0x53) &&
            (GetAsyncKeyState(VK_SHIFT)   & 0x80000000) &&
            (GetAsyncKeyState(VK_CONTROL) & 0x80000000)  &&
            (GetAsyncKeyState(VK_MENU)    & 0x80000000)) {

            RebootInitiated = TRUE;

            CreateThread(NULL, 0, RebootImmediately, NULL, 0, NULL);
            //RebootImmediately();

            return 1;
        }
    }

    return CallNextHookEx(hhookSysMsg, nCode, wParam, lParam);
}


LONG APIENTRY MainWndProc(
    HWND hWnd,                
    UINT message,             
    UINT wParam,              
    LONG lParam)              
{

    switch (message) 
    {
        case WM_CREATE:
            return 0;
 
        case WM_WINDOWPOSCHANGING:
            if (bCreated) {  
                LPWINDOWPOS lpwp;
               
                // correct WINDOWPOS parameters
                lpwp = (LPWINDOWPOS) lParam; // points to size and position data 
                lpwp->flags = SWP_NOMOVE    | SWP_NOOWNERZORDER |
                              SWP_NOSIZE | SWP_NOREDRAW | 
                              SWP_NOREPOSITION;

            } else { 
                bCreated = TRUE;
            }
            break;
        case WM_DESTROY:
            PostQuitMessage(0);
            break;

        default:
            return (DefWindowProc(hWnd, message, wParam, lParam));
    }
    return (0);
}


BOOL InitApplication(HANDLE hInstance)
{
    WNDCLASS  wcSample;
    wcSample.style = 0;                     
    wcSample.lpfnWndProc = (WNDPROC)MainWndProc; 
    wcSample.cbClsExtra = 0;
    wcSample.cbWndExtra = 0;
    wcSample.hInstance = (HINSTANCE)hInstance;       
    wcSample.hIcon = NULL; 
    wcSample.hCursor = NULL;
    wcSample.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); 
    wcSample.lpszMenuName =  NULL;  
    wcSample.lpszClassName = FAST_REBOOT_APP_CLASS;

    return (RegisterClass(&wcSample));
}

/// Perofrom instance-specific intialization
BOOL InitInstance(
    HANDLE          hInstance,
    int             nCmdShow) 
{

    HWND hWndMain;

    hWndMain = CreateWindow(
        FAST_REBOOT_APP_CLASS,
        TEXT("Fast Reboot Application"),
        WS_OVERLAPPEDWINDOW, 
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
        NULL,               
        NULL,               
        (HINSTANCE)hInstance,          
        NULL);

    if (!hWndMain)
        return (FALSE);

    ShowWindow(hWndMain, SW_HIDE);
//    ShowWindow(hWndMain, SW_SHOW);
    UpdateWindow(hWndMain); 
    return (TRUE);      

}

static const char help_text[] = 
    "Fast Reboot (c) by Alter & Axxie v1.0.i, Home site http://www.alter.org.ua\n\n"
    "Usage:\n"
    "\tfreboot\t[-<switches>]\n"
    "Exclusive switches:\n"
    "\ti\treboot immediately\n"
    "\tr\treboot\n"
    "\ts,h\tshutdown\n"
    "\tl\tlogoff\n"
    "\tp\tpoweroff\n"
    "Optional switch:\n"
    "\tf\tforces processes to terminate\n"
    "\tu\tunload user profile before Fast Reboot\n"
    "\t?\tthis help\n\n"
    "Installs FastReboot Hook if started without parameters.\n"
    "The Hook enables Fast Reboot similar to Quick Reboot\n"
    "from Windows NT in 2000/XP/2003.\n"
    "You can use ALT+CTRL+SHIFT+DEL to reboot immediately\n"
    ;


VOID print_help(VOID) {

    HANDLE stdOuth = GetStdHandle(STD_OUTPUT_HANDLE);
    ULONG WrittenBytes;

    if(stdOuth && stdOuth != ((HANDLE)(-1))) {
        WriteFile(stdOuth, help_text, strlen(help_text), &WrittenBytes, NULL);
    } else {
        MessageBox(NULL, help_text, "Usage", MB_OK);
    }
}

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow) {
    MSG msg;                       
    ULONG i;
    ULONG Flags = 0;
    ULONG lim;
    BOOLEAN break_on_q = FALSE;
    BOOLEAN break_name = FALSE;
    HANDLE th;

    lpCmdLine = GetCommandLine();
    lim = strlen(lpCmdLine);

    // skip name of executable
    if(lpCmdLine[0] == '\"') {
        // check if executable name comes in quotation marks
        break_on_q = TRUE;
    }
    // search for end of executable's name
    for (i=1; !break_name && (i<lim-1) ;i++) {
        switch(lpCmdLine[i]) {
        case '\"':
            break_name = TRUE;
            break;
        case ' ':
        case '\t':
        case '\n':
        case '\r':
            if(!break_on_q) {
                break_name = TRUE;
            }
            break;
        }
    }

    // parse command line
    for (;i<lim ;i++) {
        // skip spaces/tabs
        if(lpCmdLine[i] == ' ' || lpCmdLine[i] == '\t')
            continue;
        // now we expect switches prepended with dash
        if(lpCmdLine[i] != '-') {
            print_help();
            return 0;
        }
        // skip dash
        i++;
        if(i>=lim) {
            print_help();
            return 0;
        }
        // parse switches after dash,
        // stop on speces/tabs
        for( ; (i<lim) && !(lpCmdLine[i] == ' ' || lpCmdLine[i] == '\t') ; i++) {
            switch(lpCmdLine[i]) {
                case '?' :
                    print_help();
                    return 0;
                case 'r' :
                    Flags |= EWX_REBOOT;
                    break;
                case 'i' :
                    RebootNow = TRUE;
                    break;
                case 's' :
                case 'h' :
                    Flags |= EWX_SHUTDOWN;
                    break;
                case 'l' :
                    Flags |= EWX_LOGOFF;
                    break;
                case 'p' :
                    Flags |= EWX_POWEROFF;
                    break;
                case 'f' :
                    Flags |= EWX_FORCE;
                    break;
                case 'u':
                    UnloadProfile = TRUE;
                    break;
                default:
                    print_help();
                    return 0;
            }
        }
    }

    if(RebootNow) {
        th = CreateThread(NULL, 0, RebootImmediately, NULL, 0, NULL);
        WaitForSingleObject(th, INFINITE);
        return 0;
    }

    if (Flags) {
        GainAllPrivileges();
        ExitWindowsEx(Flags, 0);
        return 0;
    }

    if (!InitApplication(hInstance))
        return (FALSE);     

    if (!InitInstance(hInstance, nCmdShow))
        return (FALSE);

    hhookSysMsg = SetWindowsHookEx(WH_KEYBOARD_LL,&MyKeyboardProc,GetModuleHandle(NULL),0);

    if(!hhookSysMsg) {
        int RC=GetLastError();
        ExitProcess(RC);
    }

    while (GetMessage(&msg, NULL, 0,0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg); 
    }

    UnhookWindowsHookEx(hhookSysMsg);
   
    return (msg.wParam);  
    
}


